%% to create OBCS panel plots
close all
clear all
fpath   = '/net/wave3/ganeshgopal/WAVE5_DATA/GOM_OI_24DEG/FORCINGS/';
hycompath = '/net/wave3/ganeshgopal/WAVE5_DATA/GOM_OI_24DEG/hycom_15d/';


%% Grid - Mask of MITGCM model
eval(['load ' fpath 'FMT.mat']);
eval(['load ' fpath 'GRID.mat']);
nPx = 1;
nPy = 1;

%% READING NORTHERN BOUNDARY SLICE
%% X = 101 (LON), Y = 98(LAT), Z = 33(DEPTH), 121(TIME) 
nrec = 121;
time_hycom = rdslice([hycompath 'time_hycom.bin'],[1 nrec],1,fmt,Ieee);
date = ['2004_2008_GOM_OI_' datestr(time_hycom(1),3) datestr(time_hycom(1),7)];
ntottime = nrec;   


%% Position of the open boundaries (as defined in the nested model)
%% North.
obcsN = 'n';
%% South.
obcsS = 'o';
%% West.
obcsW = 'o';
%% East.
obcsE = 'o';

%% reading boundary files

%% South
if strcmp(obcsS,'o') == 1
  obsu = squeeze(rdda([fpath 'Rs_UobcsS_' date '_nPy' num2str(nPy) '.bin'],[nxc nPy nzc ntottime],1,fmt,Ieee));
  obsv = squeeze(rdda([fpath 'Rs_VobcsS_' date '_nPy' num2str(nPy) '_c1.bin'],[nxc nPy nzc ntottime],1,fmt,Ieee));
  obst = squeeze(rdda([fpath 'Rs_TobcsS_' date '_nPy' num2str(nPy) '.bin'],[nxc nPy nzc ntottime],1,fmt,Ieee));
  obss = squeeze(rdda([fpath 'Rs_SobcsS_' date '_nPy' num2str(nPy) '.bin'],[nxc nPy nzc ntottime],1,fmt,Ieee));
end

%% East
if strcmp(obcsE,'o') == 1
  obeu = squeeze(rdda([fpath 'Rs_UobcsE_' date '_nPx' num2str(nPx) '_c1.bin'],[nyc nPx nzc ntottime],1,fmt,Ieee));
  obev = squeeze(rdda([fpath 'Rs_VobcsE_' date '_nPx' num2str(nPx) '.bin'],[nyc nPx nzc ntottime],1,fmt,Ieee));
  obet = squeeze(rdda([fpath 'Rs_TobcsE_' date '_nPx' num2str(nPx) '.bin'],[nyc nPx nzc ntottime],1,fmt,Ieee));
  obes = squeeze(rdda([fpath 'Rs_SobcsE_' date '_nPx' num2str(nPx) '.bin'],[nyc nPx nzc ntottime],1,fmt,Ieee));
end

%% West
if strcmp(obcsW,'o') == 1
  obwu = squeeze(rdda([fpath 'Rs_UobcsW_' date '_nPx' num2str(nPx) '_c1.bin'],[nyc nPx nzc ntottime],1,fmt,Ieee));
  obwv = squeeze(rdda([fpath 'Rs_VobcsW_' date '_nPx' num2str(nPx) '.bin'],[nyc nPx nzc ntottime],1,fmt,Ieee));
  obwt = squeeze(rdda([fpath 'Rs_TobcsW_' date '_nPx' num2str(nPx) '.bin'],[nyc nPx nzc ntottime],1,fmt,Ieee));
  obws = squeeze(rdda([fpath 'Rs_SobcsW_' date '_nPx' num2str(nPx) '.bin'],[nyc nPx nzc ntottime],1,fmt,Ieee));
end

 
for nt = 1:25:100;
    figure('position',[100 100 1000 800])
    
    op = 'S';
    
    if (strcmp(op,'S') == 1);xc = xc;u = obsu;v = obsv; t = obst; s = obss;end
    if (strcmp(op,'E') == 1);xc = yc;u = obeu;v = obev; t = obet; s = obes;end
    if (strcmp(op,'W') == 1);xc = yc;u = obwu;v = obwv; t = obwt; s = obws;end
    
    subplot(2,2,1)
    OBCS_slice_plot(xc,zc,'U',op,u(:,:,nt),time_hycom(nt))
    subplot(2,2,2)
    OBCS_slice_plot(xc,zc,'V',op,v(:,:,nt),time_hycom(nt))
    subplot(2,2,3)
    OBCS_slice_plot(xc,zc,'T',op,t(:,:,nt),time_hycom(nt))
    subplot(2,2,4)
    OBCS_slice_plot(xc,zc,'S',op,s(:,:,nt),time_hycom(nt))
end


